unit Main;

{******************************************************************************
 Unit Name:	 Main
 Description:Main contains an example of polymorphic creation of instances of
             TBase or of its derived classes. Note that no knowledge of
             anything regarding derived classes is required.
 Author:     M. Venturini
 Revisor:
 Date:       17 Feb. 97
 Revision:
******************************************************************************}

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms, StdCtrls,
  Base;

type

  TFormMain = class(TForm)
    ClassName: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  	C: TBase;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

procedure TFormMain.FormCreate(Sender: TObject);

var
  Info: TBaseCreateInfo;

begin

  {Info object is created and filled with the creational info}
	try
		Info := TBaseCreateInfo.Create;
  	Info.Key := StrToInt(ParamStr(1));
		C := TBase.DerivedClass(Info).Create(Info);
  	Info.Free;
  	{No one knows the class of C, if you need to know ask him}
  	ClassName.Caption := 'A ' + C.ClassName + ' istance was created.';
  except
  	ClassName.Caption := 'No class matched the given parameter.';
  end;

end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin

	C.Free;

end;

end.

